/**
 * Freqtrade API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2021.12-dev21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import BlacklistPayload from '../model/BlacklistPayload';
import BlacklistResponse from '../model/BlacklistResponse';
import HTTPValidationError from '../model/HTTPValidationError';
import WhitelistResponse from '../model/WhitelistResponse';

/**
* Pairlist service.
* @module ftclient/PairlistApi
* @version 2021.12-dev21
*/
export default class PairlistApi {

    /**
    * Constructs a new PairlistApi. 
    * @alias module:ftclient/PairlistApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }



    /**
     * Blacklist
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/BlacklistResponse} and HTTP response
     */
    blacklistApiV1BlacklistGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = BlacklistResponse;
      return this.apiClient.callApi(
        '/api/v1/blacklist', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Blacklist
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/BlacklistResponse}
     */
    blacklistApiV1BlacklistGet() {
      return this.blacklistApiV1BlacklistGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Blacklist Delete
     * Provide a list of pairs to delete from the blacklist
     * @param {Object} opts Optional parameters
     * @param {Array.<String>} opts.pairsToDelete 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/BlacklistResponse} and HTTP response
     */
    blacklistDeleteApiV1BlacklistDeleteWithHttpInfo(opts) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'pairs_to_delete': this.apiClient.buildCollectionParam(opts['pairsToDelete'], 'multi')
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = BlacklistResponse;
      return this.apiClient.callApi(
        '/api/v1/blacklist', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Blacklist Delete
     * Provide a list of pairs to delete from the blacklist
     * @param {Object} opts Optional parameters
     * @param {Array.<String>} opts.pairsToDelete 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/BlacklistResponse}
     */
    blacklistDeleteApiV1BlacklistDelete(opts) {
      return this.blacklistDeleteApiV1BlacklistDeleteWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Blacklist Post
     * @param {module:model/BlacklistPayload} blacklistPayload 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/BlacklistResponse} and HTTP response
     */
    blacklistPostApiV1BlacklistPostWithHttpInfo(blacklistPayload) {
      let postBody = blacklistPayload;
      // verify the required parameter 'blacklistPayload' is set
      if (blacklistPayload === undefined || blacklistPayload === null) {
        throw new Error("Missing the required parameter 'blacklistPayload' when calling blacklistPostApiV1BlacklistPost");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = BlacklistResponse;
      return this.apiClient.callApi(
        '/api/v1/blacklist', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Blacklist Post
     * @param {module:model/BlacklistPayload} blacklistPayload 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/BlacklistResponse}
     */
    blacklistPostApiV1BlacklistPost(blacklistPayload) {
      return this.blacklistPostApiV1BlacklistPostWithHttpInfo(blacklistPayload)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Whitelist
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/WhitelistResponse} and HTTP response
     */
    whitelistApiV1WhitelistGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = WhitelistResponse;
      return this.apiClient.callApi(
        '/api/v1/whitelist', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Whitelist
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/WhitelistResponse}
     */
    whitelistApiV1WhitelistGet() {
      return this.whitelistApiV1WhitelistGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


}
